package com.bergerkiller.bukkit.nolagg.tnt;

import org.bukkit.permissions.PermissionDefault;

import com.bergerkiller.bukkit.common.Task;
import com.bergerkiller.bukkit.common.config.FileConfiguration;
import com.bergerkiller.bukkit.nolagg.base.NoLaggBase;

public class NoLaggTNT extends NoLaggBase {

	public static NoLaggTNT plugin;
	
	public NoLaggTNT() {
		super(1838, 2007);
	}

	@Override
	public void enable() {
		plugin = this;
		
		new Task(this) {
			public void run() {
				plugin.register(NLTListener.class);
			}
		}.start(1);
		this.register(new Commands());
		
		FileConfiguration config = new FileConfiguration(this);
		config.load();
		
		//tnt
		config.setHeader("This is the configuration of NoLaggTNT\n");
		config.setHeader("detonationInterval", "The interval (in ticks) at which TNT is detonated by explosions");
		config.setHeader("detonationRate", "How many TNT is detonated by explosions per interval");
		config.setHeader("explosionRadiusFactor", "The explosion crater size factor");
		config.setHeader("explosionRate", "The amount of explosion packets to send to the clients per tick");
		config.setHeader("changeBlocks", "If TNT explosions can change non-TNT blocks");

		TnTHandler.interval = config.get("detonationInterval", 1);
		TnTHandler.rate = config.get("detonationRate", 10);
		CustomExplosion.factor = config.get("explosionRadiusFactor", 1.0);
		TnTHandler.explosionRate = config.get("explosionRate", 5);
		TnTHandler.changeBlocks = config.get("changeBlocks", true);
		
		config.save();
		
		TnTHandler.init();
	}

	@Override
	public void disable() {
		TnTHandler.deinit();
	}
	
	@Override
	public void permissions() {
		this.loadPermission("nolagg.tnt.info", PermissionDefault.OP, "The player can show TNT information");
		this.loadPermission("nolagg.tnt.clear", PermissionDefault.OP, "The player can stop TNT detonation");
	}

}
